/***************************************************************************
                          koctaveview.h  -  description
                             -------------------
    begin                : Thu Oct 24 19:35:22 IST 2002
    copyright            : (C) 2002 by Matti
    email                : hei00rhe@syd.kth.se
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KOCTAVE3VIEW_H
#define KOCTAVE3VIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>

#include <kparts/part.h>


class Koctave3Doc;

/** The Koctave3View class provides the view widget for the Koctave3App instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As Koctave3View is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the Koctave3App class to manipulate and display
 * the document structure provided by the Koctave3Doc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class Koctave3View : public QWidget
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    Koctave3View(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~Koctave3View();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a Koctave3App instance as a parent
     * widget to get to the window document pointer by calling the Koctave3App::getDocument() method.
     *
     * @see Koctave3App#getDocument
     */
    Koctave3Doc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);
	
  private:
      KParts::ReadOnlyPart *part;     //konsole part
	
};

#endif // KOCTAVE3VIEW_H
